MKE2FS(8)

NAME
mke2fs - create an ext2/ext3 filesystem

SYNOPSIS
mke2fs [ -c | -l filename ] [ -b block-size ] [ -f fragment-size ] [ -g blocks-per-group ] [ -i bytes-per-inode ] [ -j ] [ -J journal-options ] [ -N number-of-inodes ] [ -n ] [ -m reserved-blocks-percentage ] [ -o creator-os ] [ -O feature[,...] ] [ -q ] [ -r fs-revision-level ] [ -E extended-options ] [ -v ] [ -F ] [ -L volume-label ] [ -M last-mounted-directory ] [ -S ] [ -T filesystem-type ] [ -V ] device [ blocks-count ] @JDEV@.sp @JDEV@.B "mke2fs -O journal_dev" @JDEV@[ @JDEV@.B -b @JDEV@.I block-size @JDEV@] @JDEV@[ @JDEV@.B -L @JDEV@.I volume-label @JDEV@] @JDEV@[ @JDEV@.B -n @JDEV@] @JDEV@[ @JDEV@.B -q @JDEV@] @JDEV@[ @JDEV@.B -v @JDEV@] @JDEV@.I external-journal @JDEV@[ @JDEV@.I blocks-count @JDEV@]

DESCRIPTION
mke2fs is used to create an ext2/ext3 filesystem (usually in a disk partition). device is the special file corresponding to the device (e.g /dev/hdXX). blocks-count is the number of blocks on the device. If omitted, mke2fs automagically figures the file system size. If called as mkfs.ext3 a journal is created as if the -j option was specified.

OPTIONS

-b block-size
    Specify the size of blocks in bytes. Valid block size vales are 1024, 2048 and 4096 bytes per block. If omitted, mke2fs block-size is heuristically determined by the file system size and the expected usage of the filesystem (see the -T option). If block-size is negative, then mke2fs will use heuristics to determine the appropriate block size, with the constraint that the block size will be at least block-size bytes. This is useful for certain hardware devices which require that the blocksize be a multiple of 2k.

-c  Check the device for bad blocks before creating the file system. If this option is specified twice, then a slower, read-write test is used instead of a fast read-only test.

-E extended-options
    Set extended options for the filesystem. Extended options are comma separated, and may take an argument using the equals ('=') sign. The -E option used to be -R in earlier versions of mke2fs. The -R option is still accepted for backwards compatibility. The following extended options are supported:

    stride=stripe-size
        Configure the filesystem for a RAID array with stripe-size filesystem blocks per stripe.

    resize=max-online-resize
        Reserve enough space so that the block group descriptor table can grow to support a filesystem that has max-online-resize blocks.

-f fragment-size
    Specify the size of fragments in bytes.

-F  Force mke2fs to run, even if the specified device is not a block special device, or appears to be mounted.

-g blocks-per-group
    Specify the number of blocks in a block group. There is generally no reason the user to ever set this parameter, as the default is optimal for the filesystem. (For administrators who are creating filesystems on RAID arrays, it is preferable to use the stride RAID parameter as part of the -R option rather than manipulating the number of blocks per group.) This option is generally used by developers who are developing test cases.

-i bytes-per-inode
    Specify the bytes/inode ratio. mke2fs creates an inode for every bytes-per-inode bytes of space on the disk. The larger the bytes-per-inode ratio, the fewer inodes will be created. This value generally shouldn't be smaller than the blocksize of the filesystem, since then too many inodes will be made. Be warned that is not possible to expand the number of inodes on a filesystem after it is created, so be careful deciding the correct value for this parameter.

-j  Create the filesystem with an ext3 journal. If the -J option is not specified, the default journal parameters will be used to create an appropriately sized journal (given the size of the filesystem) stored within the filesystem. Note that you must be using a kernel which has ext3 support in order to actually make use of the journal.

-J journal-options
    Create the ext3 journal using options specified on the command-line. Journal options are comma separated, and may take an argument using the equals ('=') sign. The following journal options are supported:

    size=journal-size
        Create an internal journal (i.e., stored inside the filesystem) of size journal-size megabytes. The size of the journal must be at least 1024 filesystem blocks (i.e., 1MB if using 1k blocks, 4MB if using 4k blocks, etc.) and may be no more than 102,400 filesystem blocks. @JDEV@.TP @JDEV@.BI device= external-journal @JDEV@Attach the filesystem to the journal block device located on @JDEV@.IR external-journal . @JDEV@The external @JDEV@journal must already have been created using the command @JDEV@.IP @JDEV@.B mke2fs -O journal_dev @JDEV@.I external-journal @JDEV@.IP @JDEV@Note that @JDEV@.I external-journal @JDEV@must have been created with the @JDEV@same block size as the new filesystem. @JDEV@.IP @JDEV@Instead of specifying a device name directly, @JDEV@.I external-journal @JDEV@can also be specified by either @JDEV@.BI LABEL= label @JDEV@or @JDEV@.BI UUID= UUID @JDEV@to locate the external journal by either the volume label or UUID @JDEV@stored in the ext2 superblock at the start of the journal. Use @JDEV@.BR dumpe2fs (8) @JDEV@to display a journal device's volume label and UUID. See also the @JDEV@.B -L @JDEV@option of @JDEV@.BR tune2fs (8).
@JDEV@.IP @JDEV@Only one of the @JDEV@.BR size " or " device @JDEV@options can be given for a filesystem.

-l filename
    Read the bad blocks list from filename. Note that the block numbers in the bad block list must be generated using the same block size as used by mke2fs. As a result, the -c option to mke2fs is a much simpler and less error-prone method of checking a disk for bad blocks before formatting it, as mke2fs will automatically pass the correct parameters to the badblocks program.

-L  Set the volume label for the filesystem.

-m reserved-blocks-percentage
    Specify the percentage of the filesystem blocks reserved for the super-user. This avoids fragmentation, and allows root-owned daemons, such as syslogd(8), to continue to function correctly after non-privileged processes are prevented from writing to the filesystem. The default percentage is 5%.

-M  Set the last mounted directory for the filesystem. This might be useful for the sake of utilities that key off of the last mounted directory to determine where the filesystem should be mounted.

-n  causes mke2fs to not actually create a filesystem, but display what it would do if it were to create a filesystem. This can be used to determine the location of the backup superblocks for a particular filesystem, so long as the mke2fs parameters that were passed when the filesystem was originally created are used again. (With the -n option added, of course!)

-N number-of-inodes
    overrides the default calculation of the number of inodes that should be reserved for the filesystem (which is based on the number of blocks and the bytes-per-inode ratio). This allows the user to specify the number of desired inodes directly.

-o creator-os
    Manually override the default value of the "creator os" field of the filesystem. Normally the creator field is set by default to the native OS of the mke2fs executable.

-O feature[,...]
    Create filesystem with given features (filesystem options), overriding the default filesystem options. Currently, the sparse_super and filetype features are turned on by default when mke2fs is run on a system with Linux 2.2 or later (unless creator-os is set to the Hurd). Filesystems that may need to be mounted on pre-2.2 Linux or other kernels should be created with -O none (or -r 0 for Linux 1.2) which will disable these features, even if mke2fs is run on a system which can support them.

    The following filesystem options are supported:

    dir_index
        Use hashed b-trees to speed up lookups in large directories.

    filetype
        Store file type information in directory entries.

    has_journal
        Create an ext3 journal (as if using the -j option). @JDEV@.TP @JDEV@.B journal_dev @JDEV@Create an external ext3 journal on the given device @JDEV@instead of a regular ext2 filesystem. @JDEV@Note that @JDEV@.I external-journal @JDEV@must be created with the same @JDEV@block size as the filesystems that will be using it.

    sparse_super
        Create a filesystem with fewer superblock backup copies (saves space on large filesystems).

-q  Quiet execution. Useful if mke2fs is run in a script.

-r revision
    Set the filesystem revision for the new filesystem. Note that 1.2 kernels only support revision 0 filesystems. The default is to create revision 1 filesystems.

-S  Write superblock and group descriptors only. This is useful if all of the superblock and backup superblocks are corrupted, and a last-ditch recovery method is desired. It causes mke2fs to reinitialize the superblock and group descriptors, while not touching the inode table and the block and inode bitmaps. The e2fsck program should be run immediately after this option is used, and there is no guarantee that any data will be salvageable. It is critical to specify the correct filesystem blocksize when using this option, or there is no chance of recovery.

-T fs-type
    Specify how the filesystem is going to be used, so that mke2fs can chose optimal filesystem parameters for that use. The supported filesystem types are:

    news
        one inode per 4kb block

    largefile
        one inode per megabyte

    largefile4
        one inode per 4 megabytes

-v  Verbose execution.

-V  Print the version number of mke2fs and exit.

AUTHOR
This version of mke2fs has been written by Theodore Ts'o <tytso@mit.edu>.

BUGS
mke2fs accepts the -f option but currently ignores it because the second extended file system does not support fragments yet.
There may be other ones. Please, report them to the author.

AVAILABILITY
mke2fs is part of the e2fsprogs package and is available from http://e2fsprogs.sourceforge.net.

SEE ALSO
badblocks(8), dumpe2fs(8), e2fsck(8), tune2fs(8)